--Indigo's Out of Character message tool.
--Version 1.0
--Author: Christine

INDIOOC_OldSendChatMessage = SendChatMessage;

local sendOOCMessage = 0;

function INDIOOC_SendChatMessage(msg, system, language, target)
	
	if (sendOOCMessage == 1) then
		msg = createOOCString(msg);
	end
	
	INDIOOC_OldSendChatMessage(msg, system, language, target);
end

SendChatMessage = INDIOOC_SendChatMessage;

-- Checks to see if the the supplied string ends with the passed pattern.
function StartsWith(sbig, slittle)
	if type(slittle) == "table" then
		for k,v in ipairs(slittle) do
			if string.sub(sbig, 1, string.len(v)) == v then
				return true
			end
		end
		return false
	end
	return string.sub(sbig, 1, string.len(slittle)) == slittle
end


-- Checks to see if the the supplied string ends with the passed pattern.
function EndsWith(sbig, slittle)
	if type(slittle) == "table" then
		for k,v in ipairs(slittle) do
			if string.sub(sbig, string.len(sbig) - string.len(v) + 1) == v then
				return true
			end
		end
		return false
	end
	return string.sub(sbig, string.len(sbig) - string.len(slittle) + 1) == slittle
end


-- Takes a string from the chat area and checks to see if it has (( string )) around it.
-- If it doesn't then it add them around the string.
function createOOCString(chatMessage)

	if not StartsWith(chatMessage,"((") then

		displayMessage = "(("..chatMessage;
	else
		displayMessage = chatMessage;

	end

	if not EndsWith(chatMessage,"))") then
		displayMessage = displayMessage.."))";
	else
		displayMessage = chatMessage;
	end

	return displayMessage;

end

SlashCmdList["INDIOOC"] = function(s)
	if(sendOOCMessage == 0) then
		sendOOCMessage =1;
		DEFAULT_CHAT_FRAME:AddMessage("Indigo's OOC output is on");
	else
		sendOOCMessage=0;
		DEFAULT_CHAT_FRAME:AddMessage("Indigo's OOC output is off");
	end
end

SLASH_INDIOOC1 ="/ooc";